//////////////////////////
//Font class.
//Version: 110113_01
//////////////////////////

#ifndef _FONT_H_
#define _FONT_H_

#include <d3d11.h>
#include <d3dx11.h>
#include <DxErr.h>
#include <xnamath.h>

#include <iostream>
using namespace std;

class FontClass
{
//Methods
public:
	FontClass()
	{
		solidColorVS_		= NULL;
		solidColorPS_		= NULL;
		inputLayout_		= NULL;
		vertexBuffer_		= NULL;
		colorMap_			= NULL;
		colorMapSampler_	= NULL;
	}

	~FontClass(){}

	void Init(ID3D11Device* d3dDevice);
	void Render(ID3D11DeviceContext* d3dContext, IDXGISwapChain* swapChain, ID3D11RenderTargetView* backBufferTarget, char* string, float posX, float posY);
	void Release();

private:

	void DrawString(ID3D11DeviceContext* d3dContext, char* message, float startX, float startY);

	inline void CompileD3DShader( WCHAR* filePath, char* entry, char* shaderModel, ID3DBlob** buffer )
	{
			ID3DBlob* errorBuffer = 0;

			D3DX11CompileFromFile( filePath, 0, 0, entry, shaderModel, D3D10_SHADER_ENABLE_STRICTNESS, 0, 0, buffer, &errorBuffer, 0 );
	}

//Data members
private:
	    ID3D11VertexShader* solidColorVS_;
        ID3D11PixelShader* solidColorPS_;

        ID3D11InputLayout* inputLayout_;
        ID3D11Buffer* vertexBuffer_;

        ID3D11ShaderResourceView* colorMap_;
        ID3D11SamplerState* colorMapSampler_;
};

#endif