/////////////////////////////////////////////////////////
// Grid rendering class.
// This class is used to construct and stream the grid
// 3D model displayed in the scene.
// Version: 100113_01
/////////////////////////////////////////////////////////

//Todo: - Add a function to randomly position the landing areas whenever a new game is started.
//		- Designate the two landing areas on the grid (orange for the landing area the player starts in, neon green for the area they need to land in).

#ifndef _GRID_H_
#define _GRID_H_

#include <d3d11.h>
#include <d3dx10math.h>

class Grid
{
public:
		Grid();
		~Grid();

		bool Init(ID3D11Device* device);
		void Render(ID3D11DeviceContext* deviceContext);
		void Shutdown();

		int GetIndexCount();

private:
	struct VertexType
	{
		D3DXVECTOR3 position;
	    D3DXVECTOR4 color;
	};

	bool InitBuffers(ID3D11Device* device);
	void ShutdownBuffers();
	void RenderBuffers(ID3D11DeviceContext* deviceContext);

public:

private:
	int m_gridWidth, m_gridHeight;
	int m_vertexCount, m_indexCount;
	ID3D11Buffer *m_vertexBuffer, *m_indexBuffer;

};

#endif