/////////////////////////////////////////////////////////////////////////
// DIrectInput based input handling class.
// Handles mouse and keyboard input for the DirectX11 application.
//
// Version: 141212_01
////////////////////////////////////////////////////////////////////////

#ifndef _INPUT_H_
#define _INPUT_H_

#define DIRECTINPUT_VERSION 0x0800
#pragma comment(lib, "dinput8.lib")
#pragma comment(lib, "dxguid.lib")

#include <dinput.h>
#include <windows.h>

class Input
{
public:
	Input();
	~Input();

	bool Init(HINSTANCE hinstance, HWND hwnd, int screenWidth, int screenHeight);
	void Shutdown();
	bool ProcessFrame();

	void GetMouseLocation(int& mouseX, int& mouseY);

private:
	bool ReadKeyboard();
	bool ReadMouse();
	void ProcessMouseInput();

public:
	unsigned char			m_keyboardState[256];
	DIMOUSESTATE			m_mouseState;
	int						m_mouseX, m_mouseY;

private:
	IDirectInput8*			m_directInput;
	IDirectInputDevice8*	m_keyboard;
	IDirectInputDevice8*	m_mouse;


	int						m_screenWidth, m_screenHeight;

};

#endif