///////////////////////////////
// Game logo class.
// Version: 150113_01
///////////////////////////////

#ifndef _LOGO_H_
#define _LOGO_H_

#include <d3d11.h>
#include <d3dx11.h>
#include <DxErr.h>
#include <xnamath.h>

class Logo
{
public:
	Logo()
	{
		solidColorVS_		= NULL;
		solidColorPS_		= NULL;
		inputLayout_		= NULL;
		vertexBuffer_		= NULL;
		colorMap_			= NULL;
		colorMapSampler_	= NULL;
	}

	~Logo(){}

	void Init(ID3D11Device* d3dDevice);
	void Render(ID3D11DeviceContext* d3dContext, IDXGISwapChain* swapChain, ID3D11RenderTargetView* backBufferTarget);
	void Release();

private:

	inline void CompileD3DShader( WCHAR* filePath, char* entry, char* shaderModel, ID3DBlob** buffer )
	{
			ID3DBlob* errorBuffer = 0;

			D3DX11CompileFromFile( filePath, 0, 0, entry, shaderModel, D3D10_SHADER_ENABLE_STRICTNESS, 0, 0, buffer, &errorBuffer, 0 );
	}

private:
		ID3D11VertexShader* solidColorVS_;
        ID3D11PixelShader* solidColorPS_;

        ID3D11InputLayout* inputLayout_;
        ID3D11Buffer* vertexBuffer_;

        ID3D11ShaderResourceView* colorMap_;
        ID3D11SamplerState* colorMapSampler_;
};

#endif