/////////////////////////////////////////////////////
// This class is used to handle the streaming of
// triangle based primitive vertex data.
//
// Version: 041212_01
////////////////////////////////////////////////////

#ifndef _PRIMITIVE_H_
#define _PRIMITIVE_H_

#include <d3d11.h>
#include <d3dx10math.h>

class Primitive
{
public:
	Primitive();
	~Primitive();

	bool Init(ID3D11Device*, D3DXVECTOR4* color_);
	void Shutdown();
	void Render(ID3D11DeviceContext*);

	int GetIndexCount();

private:

	bool InitializeBuffers(ID3D11Device*, D3DXVECTOR4* color_);
	void FreeBuffers();
	void RenderBuffers(ID3D11DeviceContext*);


public:

private:

	//Declare all corresponding vertex types here
	struct VertexType_PC
	{
		D3DXVECTOR3 position;
	    D3DXVECTOR4 color;
	};

	ID3D11Buffer *m_vertexBuffer, *m_indexBuffer;
	int m_vertexCount, m_indexCount;
};

#endif