/////////////////////////////////////////////////////////////////////
// Scene lighting class.
// Used to setup and handle al of the main
// lighting components used by the various shader techniques
// for lighting the scene. 
// 
// Version: 201212_01
/////////////////////////////////////////////////////////////////////

#ifndef _SCENE_LIGHT_H_
#define _SCENE_LIGHT_H_

#include <d3dx10math.h>

class SceneLight
{
public:
	SceneLight(){}
	~SceneLight(){}

	inline void SetDiffuseColor(float r, float g, float b, float a)
	{
		m_diffuseColor.x = r;
		m_diffuseColor.y = g;
		m_diffuseColor.z = b;
		m_diffuseColor.w = a;
	}

	inline void SetDirection(float x, float y, float z)
	{
		m_direction.x = x;
		m_direction.y = y;
		m_direction.z = z;
	}

	inline D3DXVECTOR4 GetDiffuseColor()
	{
		return m_diffuseColor;
	}

	inline D3DXVECTOR3 GetDirection()
	{
		return m_direction;
	}

private:
	D3DXVECTOR4 m_diffuseColor;
	D3DXVECTOR3 m_direction;
};

#endif