/////////////////////////////////////////////////////////////////
// Core system class.
// Handles the creation of the Win32 application window and 
// calls the Direct3D rendering class methods contained in 
// the graphics class and it's sub classes. 
// 
// Version: 041212_01
/////////////////////////////////////////////////////////////////

#ifndef _SYSTEM_H_
#define _SYSTEM_H_

#define WIN32_LEAN_AND_MEAN

#include <Windows.h>

//framework includes
#include "graphicsSystem.h"


class System
{
public:
	     //public methods
	System();
	~System();

	bool Init();
	void Run();
	void ShutDown();

	LRESULT CALLBACK MessageHandler(HWND, UINT, WPARAM, LPARAM); 

private:
		//private methods
	bool ProcessFrame();
	void InitializeWindow(int& screenWidth, int& screenHeight);
	void ShutdownWindow();


public: 
	//public data members
	HWND m_hwnd;

private:
		//private data members
	LPCWSTR m_applicationName;
	HINSTANCE m_hinstance;

	//Framework specific class instances go here
	GraphicsSystem* m_GraphicsSystem;
};

//Static class instance
static System* SystemHandle = NULL;

//WinProc function prototype
static LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

#endif