/////////////////////////////////////////////////////////////////
// High precision timer class implementation.
// Version: 090112_01
/////////////////////////////////////////////////////////////////

#include "timer.h"

void Timer::Init()
{
	QueryPerformanceFrequency((LARGE_INTEGER*)&m_frequency);

	//Milliseconds (remember this!)
	m_ticksPerMs = (float)(m_frequency / 1000);

	QueryPerformanceCounter((LARGE_INTEGER*)&m_startTime);
}

void Timer::Update()
{
	INT64 currentTime;
	float timeDifference;

	QueryPerformanceCounter((LARGE_INTEGER*)& currentTime);

	timeDifference = (float)(currentTime - m_startTime);

	m_frameTime = timeDifference / m_ticksPerMs;

	m_startTime = currentTime;
}

